<?php
 
/* 
 * +--------------------------------------------------------------------------+
 * |   	ShareThis
 * |   	Copyright (c) 2010 ShareThis, Inc.
 * |	http://sharethis.com
 * +
 * |  	Released under the GPL license
 * |	http://www.opensource.org/licenses/gpl-license.php
 * | 
 * |	This is an add-on for Joomla 
 * |	http://www.joomla.org/
 * |
 * |	**********************************************************************
 * |	This program is distributed in the hope that it will be useful, but
 * |	WITHOUT ANY WARRANTY; without even the implied warranty of
 * |	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * | 	**********************************************************************
 * |
 * | 	Plugin Name: ShareThis
 * | 	Plugin URI: http://sharethis.com
 * |	Description: Let your visitors share a post/page with others. Supports e-mail and posting to social bookmarking sites. 
 * |	Version: 6.0
 * |	Author: Author URI: http://sharethis.com
 * +--------------------------------------------------------------------------+
 */ 
 
/* no direct access*/

//echo htmlentities("<iframe src='html_intro.asp' width='100%' height='300'></iframe>");

defined( '_JEXEC' ) or die( 'Restricted access' );
if(!defined('DS')){ define('DS',DIRECTORY_SEPARATOR);} // DS is not supported by some Joomla versions
if(!class_exists('ContentHelperRoute')) require_once (JPATH_SITE . DS.'components'.DS.'com_content'.DS.'helpers'.DS.'route.php'); 

jimport('joomla.plugin.plugin');
jimport('joomla.html.parameter');
jimport( 'joomla.version' );

/**
 * plgContentShareThis
 * 
 * Creates ShareThis sharing button with each and every posts.
 * Reads the user settings and creates the button accordingly.
 */  
class plgContentShareThis  extends JPlugin {
  
	var $options = array();
	
   /**
    * Constructor
    * Loads the plugin settings and assigns them to class variables
    * 
    * @param object $subject
    */
    public function plgContentShareThis(&$subject, $config)
    {
        parent::__construct($subject, $config);

    	$jVersionOBJ = new JVersion;
        $jVersion = $jVersionOBJ->RELEASE;
 
        // Loading plugin parameters
        $this->_plugin = JPluginHelper::getPlugin('content', 'sharethis');
        if($jVersion < 1.6){
        	$this->_params = new JParameter($this->_plugin->params);
	    }else{
	    	$this->_params = new JRegistry();
			$this->_params->loadString($this->_plugin->params);
	    }
	    
	    $this->options['widget_type']		= $this->_params->get('widget_type');
        $this->options['button_style'] 		= $this->_params->get('button_style');
        $this->options['alignment'] 		= $this->_params->get('alignment');
        $this->options['widget_position'] 	= $this->_params->get('Widget_position');
        $this->options['pubKey'] 			= $this->_params->get('pubKey');
		$this->options['pinterest'] 		= $this->_params->get('pinterest', '0');
		$this->options['linkedin'] 			= $this->_params->get('linkedin', '0');
        $this->options['twitter'] 			= $this->_params->get('twitter');
        $this->options['username'] 			= $this->_params->get('username');
        $this->options['twittervia'] 		= $this->_params->get('twittervia');		
		$this->options['via'] 				= $this->_params->get('via');
        $this->options['vinstagram'] 		= $this->_params->get('vinstagram');
        $this->options['userinstagram'] 	= $this->_params->get('userinstagram');
        $this->options['donotcopy'] 		= $this->_params->get('donotcopy', NULL);
        $this->options['hashaddress'] 		= $this->_params->get('hashaddress', NULL);
        $this->options['sharethis_callesi']	= $this->_params->get('sharethis_callesi', 1);
    }
	
	/**
	 * Method to create widget
	 *
	 * Method is called by the event callbacks and the article's HTML is created
	 *
	 * @param	object		The content object.  
	 * @since	1.6
	 */
    
    public function createWidget(&$article)
    {    	
		$app = JFactory::getApplication();
		
		/* Get article link */
		$url = JURI::root().ContentHelperRoute::getArticleRoute($article->id, $article->catid);
		
		/* Return whole button style code with article title and article url values. */
		$outVal = "<DIV style='text-align:".$this->options['alignment'].";padding-bottom:30px;padding-top:10px'>";
		$outVal .= $this->showWidget().$this->getWidgetStyle($url,$article->title);
		$outVal .= "</DIV>";

		if($this->options['widget_position'] == "1"){			
			if(isset($article->text)) $article->text = $article->text.$outVal;
			else if(isset($article->introtext)) $article->introtext = $article->introtext.$outVal;
		}else if($this->options['widget_position']  == "0") {
			if(isset($article->text)) $article->text = $outVal . $article->text;
			else if(isset($article->introtext)) $article->introtext = $outVal . $article->introtext;
		}	
    }
        
	/**
	 * Method to modify content on preparation  
	 *
	 * Method is called by the view and the results are imploded and displayed in a placeholder
	 *
	 * @param	object		The content object.  
	 * @param	object		The content params
	 * @param	int			The 'page' number
	 * @since	1.6
	 */
	public function onPrepareContent(&$article, &$params, $limitstart) {
		$this->createWidget($article);
	}
	
	/**
	 * Method to modify content before displaying the content  
	 *
	 * Method is called by the view and the results are imploded and displayed in a placeholder
	 *
	 * @param	object		The object.  
	 * @param	object		The article
	 * @since	1.6
	 */
	
    public function onContentBeforeDisplay($item, &$article)
	{
		$this->createWidget($article);
    }
    
	/**
     * Validate Style of widget. 
	 * Display applicable ShareThis widget. 
     */
	private function getWidgetStyle($url,$title)
	{
		$span_open = '<span st_url="'.$url.'" st_title="'.$title.'" ';
		$span_close = '></span>';
		$twitter_services = "";
		if($this->options['twitter']  == '0'){ 
			$twitter_services .= ' st_username="'.trim($this->options['username']).'" ';
		}
		if($this->options['twittervia']  == '0'){ 
			$twitter_services .= ' st_via="'.trim($this->options['via']).'" ';
		}
		$instagram_services = "";
		$facebook_displayText = ' displayText="Facebook"';
		$email_displayText = ' displayText="Email"';
		$sharethis_displayText = ' displayText="ShareThis"';
		$twitter_displayText = ' displayText="Tweet"';
		$pinterest_displayText = ' displayText="Pinterest"';
		$linkedin_displayText = ' displayText="LinkedIn"';
		$instagram_displayText = ' displayText="Instagram"';

		switch($this->options['button_style'])
		{
			case 'lg-horizontal':
				$facebook_class = 'st_facebook_hcount';
				$email_class = 'st_email_hcount';
				$sharethis_class = 'st_sharethis_hcount';
				$twitter_class = 'st_twitter_hcount';
				$pinterest_class = 'st_pinterest_hcount';
				$linkedin_class = 'st_linkedin_hcount';
				$instagram_class = 'st_instagram_hcount';
			break;
			case 'lg-vertical':
				$facebook_class = 'st_facebook_vcount';
				$email_class = 'st_email_vcount';
				$sharethis_class = 'st_sharethis_vcount';
				$twitter_class = 'st_twitter_vcount';
				$pinterest_class = 'st_pinterest_vcount';
				$linkedin_class = 'st_linkedin_vcount';
				$instagram_class = 'st_instagram_vcount';
			break;
			case 'sm-classic':
				$sharethis_class = 'st_sharethis';
				return ($span_open.' class="'.$sharethis_class.'" '.$sharethis_displayText.$twitter_services.$span_close);
				exit();
			break;
			case 'sm-regular':
				$facebook_class = 'st_facebook';
				$email_class = 'st_email';
				$sharethis_class = 'st_sharethis';
				$twitter_class = 'st_twitter';
				$pinterest_class = 'st_pinterest';
				$linkedin_class = 'st_linkedin';
				$instagram_class = 'st_instagram';
			break;
			case 'sm-notext':
				$facebook_class = 'st_facebook';
				$email_class = 'st_email';
				$sharethis_class = 'st_sharethis';
				$twitter_class = 'st_twitter';
				$pinterest_class = 'st_pinterest';
				$linkedin_class = 'st_linkedin';
				$instagram_class = 'st_instagram';
				
				$facebook_displayText = '';
				$email_displayText = '';
				$sharethis_displayText = '';
				$twitter_displayText = '';
				$pinterest_displayText = '';
				$linkedin_displayText = '';
				$instagram_displayText = '';
			break;
			case 'lg-icons':
				$facebook_class = 'st_facebook_large';
				$email_class = 'st_email_large';
				$sharethis_class = 'st_sharethis_large';
				$twitter_class = 'st_twitter_large';
				$pinterest_class = 'st_pinterest_large';
				$linkedin_class = 'st_linkedin_large';
				$instagram_class = 'st_instagram_large';
			break;
			case 'button':
			default:
				$facebook_class = 'st_facebook_buttons';
				$email_class = 'st_email_buttons';
				$sharethis_class = 'st_sharethis_buttons';
				$twitter_class = 'st_twitter_buttons';
				$pinterest_class = 'st_pinterest_buttons';
				$linkedin_class = 'st_linkedin_buttons';
				$instagram_class = 'st_instagram_buttons';
			break;
		}
		
		$outputTag = $span_open.' class="'.$facebook_class.'" '.$facebook_displayText.$span_close;
		$outputTag .= $span_open.' class="'.$twitter_class.'" '.$twitter_displayText.$twitter_services.$span_close;
		if(($this->options['linkedin'])=='0'){
			$outputTag .= $span_open.' class="'.$linkedin_class.'" '.$linkedin_displayText.$span_close;
		}
		$outputTag .= $span_open.' class="'.$email_class.'" '.$email_displayText.$span_close;
		$outputTag .= $span_open.' class="'.$sharethis_class.'" '.$sharethis_displayText.$twitter_services.$span_close;
				
		if(($this->options['pinterest'])=='0'){
			$outputTag .= $span_open.' class="'.$pinterest_class.'" '.$pinterest_displayText.$span_close;
		}
		
		if($this->options['vinstagram']  == '0'){
			$instagram_services = ' st_username="'.trim($this->options['userinstagram']).'" ';
			$outputTag .= $span_open.' class="'.$instagram_class.'" '.$instagram_displayText.$instagram_services.$span_close;
		}
		
		return $outputTag;
	}
	

	/**
     * Validate type of ShareThis widget version (4.x or 5.x).
	 * Display applicable ShareThis widget. 
     */
	private function showWidget()
    {
		/* Validation for sharethis widget version */
		if(($this->options['widget_type'])!=0){
			/* New version of shareThis widget i.e. 5.x */
			$newWidget = "<script type='text/javascript'>var switchTo5x=true;</script>";
		}else{
			/* Old version of shareThis widget 4.x */
			$newWidget ="";
		}

		/* Add main js file (button.js) */
		$includeButtonScript = "<script type='text/javascript' src='http://w.sharethis.com/button/buttons.js'></script><script type='text/javascript'>stLight.options({publisher:'".$this->options['pubKey']."'".$this->getCNSConfig()."});</script>";		
		
		/* Add script and widget elements to the current page.*/
		return $newWidget.$includeButtonScript;
    }
    
    private function getCNSConfig()
    {
    	if($this->options['sharethis_callesi'] == 0){
	    	$cnsConfig = array();
	    	if(($this->options['donotcopy'])=='0'){
	    		$cnsConfig['doNotCopy'] = false;
	    	}else{
	    		$cnsConfig['doNotCopy'] = true;
	    	}
	
	    	if(($this->options['hashaddress'])=='0'){
	    		$cnsConfig['hashAddressBar'] = true;
	    	}else{
	    		$cnsConfig['hashAddressBar'] = false;
	    	}
	    	
    		if(!($cnsConfig["hashAddressBar"]) && $cnsConfig["doNotCopy"]){
				$cnsConfig["doNotHash"] = true;
			}else{
				$cnsConfig["doNotHash"] = false;
			}
	    	
	    	if(isset($cnsConfig['hashAddressBar']) && isset($cnsConfig['doNotCopy'])){	    	
		    	$retJSON = json_encode($cnsConfig);
		    	$retJSON = substr($retJSON,1,strlen($retJSON)-2);
	    		return (','.$retJSON);
	    	}else{
	    		return '';
	    	}
    	}else{
    		return '';
    	}
	}	
}